<?php defined('SYSPATH') or die('No direct script access.');

class Controller_Handler_CourseWork extends Controller_Handler_Api
{
    /** @var  Model_User_Teacher */
    protected $user;

    public function action_create() {
        $this->user->checkAccess(User::RIGHTS_TEACHER);

        $coWork = Model_CourseWork::make()
            ->author($this->user->TeacherID)
            ->semester($this->post['semesterID'])
            ->faculty($this->post['facultyID'])
            ->grade($this->post['gradeID'])
            ->subtype($this->post['subtype'])
            ->subject($this->post['subjectID'])
            ->create();

        // Attach all teachers of the department to coursework
        if ($coWork->Subtype == Model_CourseWork::SCIENTIFIC) {
            $teachers = Model_Teachers::ofDepartment($this->user->DepID);
            foreach ($teachers as $teacher)
                $coWork->bind(Model_Teacher::with($teacher['ID']));
        }

        $module = Model_Map::of($coWork)->addModule($this->user->TeacherID, 'Курсовая работа');
        Model_Map::addSubmodule($this->user->TeacherID, $module, 'landmark', 100, 'Отчёт');

        // Response to json client
        return ['ID' => $coWork->ID];
    }
}
