<?php defined('SYSPATH') or die('No direct script access.');

class Controller_Handler_Subjects extends Controller_Handler
{
    public function before() {
        parent::before();

        $this->user->checkAccess(User::RIGHTS_ADMIN | User::RIGHTS_DEAN);
    }

    public function action_create() {
        $facultyID = $this->user->isAdmin() ? $_POST['facultyID'] : $this->user->Faculty->ID;
        $id = Model_Subject::create($_POST['name'], $_POST['abbr'], $facultyID);
        
        $res = [
            'success' => ($id >= 0),
            'error' => ($id < 0),
            'message' => 
                ($id < 0 ?
                    'Предмет не добавлен!' 
                : ($id > 0 ?
                    'Предмет уже существует!'
                : 'Предмет добавлен!')),
        ];
        
        $this->response->body(json_encode($res));
    }
}
